// testview.cpp : implementation of the CTestView class
//

#include "stdafx.h"
#include "test.h"

#include "testdoc.h"
#include "testview.h"
#include "settextd.h"
#include "maxlevel.h"
#include "additemd.h"
#include "insertd.h"
#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestView
IMPLEMENT_DYNCREATE(CTestView, CView)

BEGIN_MESSAGE_MAP(CTestView, CView)
	//{{AFX_MSG_MAP(CTestView)
	ON_WM_SETFOCUS()
	ON_COMMAND(IDM_GET_STREAMSIZE, OnGetStreamsize)
	ON_COMMAND(IDM_GET_STREAMTEXT, OnGetStreamtext)
	ON_COMMAND(IDM_SET_STREAMTEXT, OnSetStreamtext)
	ON_COMMAND(IDM_GET_MAXLEVEL, OnGetMaxlevel)
	ON_COMMAND(IDM_GET_FONT, OnGetFont)
	ON_COMMAND(IDM_FLUSH, OnFlush)
	ON_COMMAND(IDM_DELETE_ITEM, OnDeleteItem)
	ON_COMMAND(IDM_GET_NODESIZE, OnGetNodesize)
	ON_COMMAND(IDM_GET_NUMNODES, OnGetNumnodes)
	ON_COMMAND(IDM_GET_NODETEXT, OnGetNodetext)
	ON_COMMAND(IDM_GOTO_TOP, OnGotoTop)
	ON_COMMAND(IDM_GOTO_FORWARD, OnGoForward)
	ON_COMMAND(IDM_GOTO_BOTTOM, OnGotoBottom)
	ON_COMMAND(IDM_GOTO_BACKWARD, OnGoBackward)
	ON_COMMAND(IDM_SET_NODETEXT, OnSetNodetext)
	ON_COMMAND(IDM_SET_FONT, OnSetFont)
	ON_COMMAND(IDM_SET_MAXLEVEL, OnSetMaxlevel)
	ON_COMMAND(IDM_ADD_ITEM, OnAddItem)
	ON_COMMAND(IDM_INSERT, OnInsert)
	ON_COMMAND(IDM_INDENT_IN, OnIndentIn)
	ON_COMMAND(IDM_INDENT_OUT, OnIndentOut)
	ON_UPDATE_COMMAND_UI(IDM_GET_FONT, OnUpdateGetFont)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_WM_SIZE()
	ON_COMMAND(IDM_STYLE, OnStyle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestView construction/destruction

CTestView::CTestView()
{
	hWnd1 = NULL;
	hWnd2 = NULL;  
	ActiveWindow = NULL;      
	hFont1 = NULL;
	hFont2 = NULL;
}

CTestView::~CTestView()
{
	if (hWnd1 != NULL)
		::DestroyWindow(hWnd1);
		
	if (hWnd2 != NULL)
		::DestroyWindow(hWnd2);
		
	if (hFont1 != NULL)
		DeleteObject(hFont1);
		
	if (hFont2 != NULL)
		DeleteObject(hFont2);
}

void CTestView::OnInitialUpdate()
{       
RECT	rect, rect1;

	//Call base class
	CView::OnInitialUpdate();

	//Set the coordinates for the first window
	GetClientRect(&rect);
	
	rect1.top = 0;
	rect1.left = 0;
	rect1.bottom = rect.bottom;
	rect1.right = rect.right/2;
     
	//Create the first outline window
	hWnd1 = ::CreateWindow("taOutline", "", WS_BORDER | WS_CHILD | WS_VISIBLE | 
	  WS_CLIPSIBLINGS, rect1.left, rect1.top, rect1.right, rect1.bottom, 
	  m_hWnd, (HMENU) IDC_OUTLINE1, AfxGetInstanceHandle(), NULL);
	  
	if (hWnd1 == NULL)
		{
	  	MessageBox("Could not create Outline 1!", "Error", MB_ICONHAND | 
	  	  MB_OK);
	  	hWnd1 = NULL;
	  	} 
	  	
	ActiveWindow = hWnd1;                                        
	  	
	rect1.left = rect1.right;
	rect1.right = rect.right/2;
	  	
	//Create the second outline window
	hWnd2 = ::CreateWindow("taOutline", "", WS_BORDER | WS_CHILD | WS_VISIBLE |
	  WS_CLIPSIBLINGS, rect1.left, rect1.top, rect1.right, rect1.bottom, 
	  m_hWnd, (HMENU) IDC_OUTLINE2, AfxGetInstanceHandle(), NULL);
	  
	if (hWnd2 == NULL)
		{
	  	MessageBox("Could not create Outline 2!", "Error", MB_ICONHAND | 
	  	  MB_OK);
	  	hWnd2 = NULL;
	  	}               
			  	
}
/////////////////////////////////////////////////////////////////////////////
// CTestView drawing

void CTestView::OnDraw(CDC* pDC)
{
	CTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CTestView diagnostics

#ifdef _DEBUG
void CTestView::AssertValid() const
{
	CView::AssertValid();
}

void CTestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTestDoc* CTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestDoc)));
	return (CTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestView message handlers

void CTestView::OnSetFocus(CWnd* pOldWnd)
{
	CView::OnSetFocus(pOldWnd);
	
	::SetFocus(ActiveWindow);
	
}

void CTestView::OnGetStreamsize()
{    
unsigned long   ulSize;
CString			str;
    
    //Get the size
	ulSize = (unsigned long) ::SendMessage(ActiveWindow, 
	  OL_GET_TEXT_STREAM_SIZE, 0, 0L);
	  
	wsprintf(str.GetBuffer(256), "The size of the delimited text is %lu", ulSize);
	str.ReleaseBuffer(-1);
	  
	//Tell the user	           
	MessageBox(str, "TaOutline Tester", MB_ICONINFORMATION | MB_OK);
	
}

void CTestView::OnGetStreamtext()
{
unsigned long   ulSize;

    
    //Get the size
	ulSize = (unsigned long) ::SendMessage(ActiveWindow, 
	  OL_GET_TEXT_STREAM_SIZE, 0, 0L);
	  
	//Create Buffer for the stuff
	char *pBuffer = new char[ulSize];
	
	                      
	//Get the buffer	                      
	::SendMessage(ActiveWindow, OL_GET_TEXT_STREAM, (WPARAM) ulSize, 
	  (LPARAM) (LPSTR) pBuffer);
	  
	//Get a file name to save the stream to
	CFileDialog cFileSave(FALSE, "TAO", "TEMP.TAO", OFN_HIDEREADONLY |
	  OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST, 
	  "Outline Files (*.tao)|*.tao|All Files (*.*)|*.*||", this);
	  
	int nResult = cFileSave.DoModal();
	
	if (nResult == IDOK)
		{
		CString strPathName = cFileSave.GetPathName();
		
		TRY //To open the file
			{
			CFile cf(strPathName, CFile::modeCreate | CFile::modeWrite);
			
			TRY //To put our stream text in the file
				{
				cf.WriteHuge(pBuffer, ulSize);
				cf.Flush();
				}
			CATCH(CFileException, e)
				{
				MessageBox("Could not write to file", "Error", MB_ICONSTOP |
			  	  MB_OK);
				} 
			END_CATCH
			}
		CATCH(CFileException, e)
			{
			MessageBox("File could not be opened", "Error", MB_ICONSTOP | 
			  MB_OK);
			}
		END_CATCH
		
		}

	delete [] pBuffer;
}

void CTestView::OnSetStreamtext()
{   
char	*pBuffer = NULL;

	//Get the file from the user
	CFileDialog cFileSave(TRUE, "TAO", "TEMP.TAO", OFN_HIDEREADONLY |
	  OFN_PATHMUSTEXIST, "Outline Files (*.tao)|*.tao|All Files (*.*)|*.*||",
	  this);
	  
	int nResult = cFileSave.DoModal();
	
	if (nResult == IDOK)
		{
		CString strPathName = cFileSave.GetPathName();
		
		TRY //To open the file
			{
			CFile cf(strPathName, CFile::modeRead);
			
			TRY //To put read our stream text from the file
				{                 
				//Find out the size of the file
				unsigned long ulLen = cf.GetLength();
				
				pBuffer = new char[ulLen];
				                            
				//Read it in
				cf.ReadHuge(pBuffer, ulLen);
				
				//See if we should blank out the ourtline first
				int nRes = MessageBox("Would you like to clear the control first?",
				  "TaOutline", MB_ICONQUESTION | MB_YESNO);
				  
				if (nRes == IDYES)
					::SendMessage(ActiveWindow, OL_FLUSH, 0, 0L);
				
				//Place it in the outline control
				::SendMessage(ActiveWindow, OL_SET_TEXT_STREAM, 
				  (WPARAM) ulLen, (LPARAM) (LPVOID) pBuffer);
				}
			CATCH(CFileException, e)
				{
				MessageBox("Could not read in file", "Error", MB_ICONSTOP |
			  	  MB_OK);
			  	  
			  	 delete [] pBuffer;
				} 
			END_CATCH
			}
		CATCH(CFileException, e)
			{
			MessageBox("File could not be opened", "Error", MB_ICONSTOP | 
			  MB_OK);              
			  
			delete [] pBuffer;
			}
		END_CATCH
		}
}

void CTestView::OnGetMaxlevel()
{            
CString str;
                  
	//Get the max level                  
	int n = (int) ::SendMessage(ActiveWindow, OL_GET_MAX_INDENT_LEVEL, 0, 0L);
	
	wsprintf(str.GetBuffer(256), "The maximum indent level is %d.", n);
	
	str.ReleaseBuffer(-1);
	
	MessageBox(str, "TaOutline Test", MB_ICONINFORMATION | MB_OK);	
}

void CTestView::OnGetFont()
{
HFONT 	hFont;
LOGFONT	lf;
char strWeight[20], strCharSet[20], strOutPrecision[20], strClip[20];
char strQuality[20], strPandF[64], str[512], str1[512], szFaceName[128];  

	//You will notice that this section is pretty large.  The key is however
	//In the next statement.  After you get the LOGFONT, you can then create
	//one on your own.  Please note that until you set the font, there is
	//no valid information in the return from this function

	//Get the font
	hFont = (HFONT) ::SendMessage(ActiveWindow, OL_GET_FONT, 0, 0L);
	
	//Get information about the font
	GetObject((HGDIOBJ) hFont, sizeof(LOGFONT), (void *) (&lf));
	
	switch (lf.lfWeight)
		{
		case FW_DONTCARE:
			lstrcpy(strWeight,"FW_DONTCARE");
			break;
		case FW_THIN:
			lstrcpy(strWeight,"FW_THIN");
			break;
		case FW_EXTRALIGHT:
			lstrcpy(strWeight,"FW_EXTRALIGHT");
			break;
			
/* Not Defined unique in the SDK
		case FW_ULTRALIGHT:
			lstrcpy(strWeight,"FW_ULTRALIGHT");
			break;
*/
		case FW_LIGHT:
			lstrcpy(strWeight,"FW_LIGHT");
			break;
		case FW_NORMAL:
			lstrcpy(strWeight,"FW_NORMAL");
			break;  
			
/* Not Defined unique in the SDK
		case FW_REGULAR:
			lstrcpy(strWeight,"FW_REGULAR");
			break;              
*/
			
		case FW_MEDIUM:
			lstrcpy(strWeight,"FW_MEDIUM");
			break;
		case FW_SEMIBOLD:
			lstrcpy(strWeight,"FW_SEMIBOLD");
			break;
			
/* Not Defined unique in the SDK			
		case FW_DEMIBOLD:
			lstrcpy(strWeight,"FW_DEMIBOLD");
			break;              
*/
			
		case FW_BOLD:
			lstrcpy(strWeight,"FW_BOLD");
			break;
		case FW_EXTRABOLD:
			lstrcpy(strWeight,"FW_EXTRABOLD");
			break;
			
/* Not Defined unique in the SDK			
		case FW_ULTRABOLD:
			lstrcpy(strWeight,"FW_ULTRABOLD");
			break;
*/
			
		case FW_BLACK:
			lstrcpy(strWeight,"FW_BLACK");
			break;
			
/* Not Defined unique in the SDK			
		case FW_HEAVY:
			lstrcpy(strWeight,"FW_HEAVY");
			break;
*/
			
		default:
			lstrcpy(strWeight,"Unknown");
			break;
		}
		
	switch (lf.lfCharSet)
		{
		case ANSI_CHARSET:
			lstrcpy(strCharSet,"ANSI_CHARSET");
			break;
		case DEFAULT_CHARSET:
			lstrcpy(strCharSet,"DEFAULT_CHARSET");
			break;
		case SYMBOL_CHARSET:
			lstrcpy(strCharSet,"SYMBOL_CHARSET");
			break;
		case SHIFTJIS_CHARSET:
			lstrcpy(strCharSet,"SHIFTJIS_CHARSET");
			break;
		case OEM_CHARSET:
			lstrcpy(strCharSet,"OEM_CHARSET");
			break;
		default:
			lstrcpy(strCharSet,"Unknown");
			break;
		}
		
	switch (lf.lfOutPrecision)
		{
		case OUT_CHARACTER_PRECIS:
			lstrcpy(strOutPrecision,"OUT_CHARACTER_PRECIS");
			break;
		case OUT_DEFAULT_PRECIS:                     
			lstrcpy(strOutPrecision,"OUT_DEFAULT_PRECIS");
			break;
		case OUT_DEVICE_PRECIS:
			lstrcpy(strOutPrecision,"OUT_DEVICE_PRECIS");
			break;
		case OUT_STRING_PRECIS:
			lstrcpy(strOutPrecision,"OUT_STRING_PRECIS");
			break;
		case OUT_STROKE_PRECIS:
			lstrcpy(strOutPrecision,"OUT_STROKE_PRECIS");
			break;
		case OUT_TT_PRECIS:
			lstrcpy(strOutPrecision,"OUT_TT_PRECIS");
			break;
		case OUT_RASTER_PRECIS:
			lstrcpy(strOutPrecision,"OUT_RASTER_PRECIS");
			break;
		case OUT_TT_ONLY_PRECIS:
			lstrcpy(strOutPrecision,"OUT_TT_ONLY_PRECIS");
			break;
		default:  
			lstrcpy(strOutPrecision,"Unknown");
			break;
		}
		
	switch (lf.lfClipPrecision)
		{
		case CLIP_LH_ANGLES:
			lstrcpy(strClip,"CLIP_LH_ANGLES");
			break;
		case CLIP_EMBEDDED:           
			lstrcpy(strClip,"CLIP_EMBEDDED");
			break;
		case CLIP_DEFAULT_PRECIS:
			lstrcpy(strClip,"CLIP_DEFAULT_PRECIS");
			break;
		case CLIP_CHARACTER_PRECIS:
			lstrcpy(strClip,"CLIP_CHARACTER_PRECIS");
			break;
		case CLIP_MASK:
			lstrcpy(strClip,"CLIP_MASK");
			break;
		case CLIP_STROKE_PRECIS:
			lstrcpy(strClip,"CLIP_STROKE_PRECIS");
			break;
		case CLIP_TT_ALWAYS:
			lstrcpy(strClip,"CLIP_TT_ALWAYS");
			break;
		default:  
			lstrcpy(strClip,"Unknown");
			break;
		}
		
	switch (lf.lfQuality)
		{
		case DEFAULT_QUALITY:
			lstrcpy(strQuality,"DEFAULT_QUALITY");
			break;
		case DRAFT_QUALITY:
			lstrcpy(strQuality,"DRAFT_QUALITY");
			break;
		case PROOF_QUALITY:
			lstrcpy(strQuality,"PROOF_QUALITY");
			break;
		default:  
			lstrcpy(strQuality,"Unknown");
			break;
		}              
		
	BOOL bShowName1 = FALSE;
	BOOL bShowName2 = FALSE;
		
	if (lf.lfPitchAndFamily & DEFAULT_PITCH)
		{
		lstrcpy(strPandF,"DEFAULT_PITCH | ");
		bShowName1 = TRUE;
		}
	else
		if (lf.lfPitchAndFamily & VARIABLE_PITCH)
			{
			lstrcpy(strPandF,"VARIABLE_PITCH | ");
			bShowName1 = TRUE;
			}
		else
			if (lf.lfPitchAndFamily & FIXED_PITCH)
				{
				lstrcpy(strPandF,"FIXED_PITCH | ");
				bShowName1 = TRUE;
				}
			else
				lstrcpy(strPandF,"Unknown Pitch | ");
				
	if (lf.lfPitchAndFamily & FF_DECORATIVE)
		{
		lstrcat(strPandF ,"FF_DECORATIVE");
		bShowName2 = TRUE;
		}
	else
		if (lf.lfPitchAndFamily & FF_DONTCARE)
			{
			lstrcat(strPandF ,"FF_DONTCARE");
			bShowName2 = TRUE;
			}
		else
			if (lf.lfPitchAndFamily & FF_MODERN)
				{
				lstrcat(strPandF ,"FF_MODERN");
				bShowName2 = TRUE;
				}
			else
				if (lf.lfPitchAndFamily & FF_ROMAN)
					{
					lstrcat(strPandF ,"FF_ROMAN");
					bShowName2 = TRUE;
					}
				else
					if (lf.lfPitchAndFamily & FF_SCRIPT)
						{
						lstrcat(strPandF ,"FF_SCRIPT");
						bShowName2 = TRUE;
						}
					else
						if (lf.lfPitchAndFamily & FF_SWISS)
							{
							lstrcat(strPandF ,"FF_SWISS");
							bShowName2 = TRUE;
							}
						else
							lstrcat(strPandF ,"Unknown Family");
						
	
	//Set up the format string
	lstrcpy(str,"The font has the following information:\nHeight = %d\n");
	lstrcat(str ,"Width = %d\nEscapement = %d\nOrientation = %d\n");
	lstrcat(str ,"Weight = %s\nItalic = %d\nUnderline = %d\nStrikeout = %d\n");
	lstrcat(str ,"Char Set = %s\nOut Precision = %s\nClip Precision = %s\n");
	lstrcat(str ,"Quality = %s\nPitch & Family = %s\nName = %s");
		                
	if ((!bShowName1 || !bShowName2) && !isalpha((int)lf.lfFaceName))
		//This one usually doen't work unless you set it
		lstrcpy(szFaceName, "Undefined");
	else
		lstrcpy(szFaceName, lf.lfFaceName);
		
	//Format the output string	                
	sprintf(str1, str, lf.lfHeight, lf.lfWidth, 
	  lf.lfEscapement, lf.lfOrientation, strWeight, lf.lfItalic, 
	  lf.lfUnderline, lf.lfStrikeOut, strCharSet, strOutPrecision, 
	  strClip, strQuality, strPandF, szFaceName);  
	  
	//Show the font info to the user	
	MessageBox(str1, "TaOutline Test", MB_ICONINFORMATION | MB_OK);	
}

void CTestView::OnFlush()
{                                                
	//Flush the window
	::SendMessage(ActiveWindow, OL_FLUSH, 0, 0L);
}

void CTestView::OnDeleteItem()
{
	//Tell the control to delete the current node
	::SendMessage(ActiveWindow, OL_DELETE, OL_NONODE, 0L);	
}

void CTestView::OnGetNodesize()
{                     
	//Find the current Node
	int nNode = (int) ::SendMessage(ActiveWindow, OL_GET_CURRENT_NODE, 0, 0L);
	     
	//Find the size
	int nSize = (int) ::SendMessage(ActiveWindow, OL_GET_NODE_TEXT_SIZE, 
	  (WPARAM) nNode, 0L);
	               
	//Make sure there was a node
	if (nSize == OL_ERROR)
		MessageBox("There is no current node", "TaOutline Test", MB_ICONSTOP | 
		  MB_OK);
	else
		{
	    char szBuf[256];
		wsprintf(szBuf, "The size of the node is %d", nSize);
		MessageBox(szBuf, "TaOutline Test", MB_ICONEXCLAMATION | MB_OK);
	    }
}

void CTestView::OnGetNumnodes()
{
	int n = (int) ::SendMessage(ActiveWindow, OL_GET_NUM_NODES, 0, 0L);
	
	char szBuf[64];
	
	sprintf(szBuf, "This control contains %d node(s).", n);
	
	MessageBox(szBuf, "TaOutline Test", MB_ICONINFORMATION | MB_OK);
	
}

void CTestView::OnGetNodetext()
{
	//Find the current Node
	int nNode = (int) ::SendMessage(ActiveWindow, OL_GET_CURRENT_NODE, 0, 0L);
	                            
	//Find the Size	                            
	int nSize = (int) ::SendMessage(ActiveWindow, OL_GET_NODE_TEXT_SIZE, 
	  (WPARAM) nNode, 0L);
	  
	if (nSize == OL_ERROR)
		MessageBox("There is no current node", "TaOutline Test", MB_ICONSTOP | 
		  MB_OK);
	else
		{
	    char *szBuf = new char[nSize+1];    
	    
	    //Get the text
	    ::SendMessage(ActiveWindow, OL_GET_NODE_TEXT, (WPARAM) nNode, 
	      (LPARAM) (LPSTR) szBuf);
	      
	    char *szText = new char [nSize+31];
		sprintf(szText, "The text in the node is:\n%s", szBuf);
		
		MessageBox(szText, "TaOutline Test", MB_ICONEXCLAMATION | MB_OK);
		
		//Clean up
		delete [] szBuf;
		delete [] szText;
	    }
}

void CTestView::OnGotoTop()
{
	::SendMessage(ActiveWindow, OL_TOP, 0, 0L);
	
}

void CTestView::OnGoForward()
{
	::SendMessage(ActiveWindow, OL_MOVE_FORWARD, 0, 0L);
	
}

void CTestView::OnGotoBottom()
{
	::SendMessage(ActiveWindow, OL_BOTTOM, 0, 0L);
	
}

void CTestView::OnGoBackward()
{
	::SendMessage(ActiveWindow, OL_MOVE_BACKWARD, 0, 0L);
	
}

void CTestView::OnSetNodetext()
{
CSetTextDlg	Dlg;

	//Find out the text already in the control
	//Find the current Node
	int nNode = (int) ::SendMessage(ActiveWindow, OL_GET_CURRENT_NODE, 0, 0L);
	                            
	//Find the Size	                            
	int nSize = (int) ::SendMessage(ActiveWindow, OL_GET_NODE_TEXT_SIZE, 
	  (WPARAM) nNode, 0L);
	  
	if (nSize == OL_ERROR)
		MessageBox("There is no current node", "TaOutline Test", MB_ICONSTOP | 
		  MB_OK);
	else
		{
	    char *szBuf = new char[nSize+1];    
	    
	    //Get the text
	    ::SendMessage(ActiveWindow, OL_GET_NODE_TEXT, (WPARAM) nNode, 
	      (LPARAM) (LPSTR) szBuf);
	      
	    Dlg.m_Text = szBuf;
	    if (IDOK == Dlg.DoModal())
	    	//Place this new text in the node
	    	::SendMessage(ActiveWindow, OL_SET_NODE_TEXT, (WPARAM) nNode,
	    	  (LPARAM) (const char FAR *)Dlg.m_Text);
	                               
		//Clean up
		delete [] szBuf;
	    }
}

void CTestView::OnSetFont()
{
HFONT hFont;
LOGFONT lf = {0};  
BOOL	bGetIt = FALSE;                  
                  
	//Make sure the font for this window was set
	if (ActiveWindow == hWnd1)
		{
		if (hFont1)    
			bGetIt = TRUE;
		}
	else 
		{
		if (hFont2)
			bGetIt = TRUE;
		}
	
	if (bGetIt)
		{
		//Get the current logical font structure
		hFont = (HFONT) ::SendMessage(ActiveWindow, OL_GET_FONT, 0, 0L);
	
		//Get information about the font
		GetObject((HGDIOBJ) hFont, sizeof(LOGFONT), (void *) (&lf));
		}
	
	CFontDialog Dlg(&lf, CF_SCREENFONTS|CF_INITTOLOGFONTSTRUCT);
	
	if (Dlg.DoModal() == IDOK)
		{
		//Set the font in the control
		hFont = CreateFontIndirect(Dlg.m_cf.lpLogFont);
		
		::SendMessage(ActiveWindow, WM_SETFONT, (WPARAM) hFont, MAKELONG(TRUE, 0));
		
		//Find the current window number
		if (hWnd1 == ActiveWindow)
			hFont1 = hFont;
		else
			hFont2 = hFont;
		}
}

void CTestView::OnSetMaxlevel()
{                                           
CMaxLevelDlg Dlg;

	//Find out what the max level was before
	int n = (int) ::SendMessage(ActiveWindow, OL_GET_MAX_INDENT_LEVEL, 0, 0L);
	
	//Set it in the dialog
	Dlg.m_Level = n;
	
	if (Dlg.DoModal() == IDOK)
		::SendMessage(ActiveWindow, OL_SET_MAX_INDENT_LEVEL, Dlg.m_Level,
		  0L);
}

void CTestView::OnAddItem()
{
CAddItemDlg Dlg;

	//Get the text from the user first
	if (IDOK == Dlg.DoModal())
		::SendMessage(ActiveWindow, OL_ADD_NODE, 0, 
		  (LPARAM) (const char FAR *) Dlg.m_Text);
}

void CTestView::OnInsert()
{
CInsertDlg Dlg;

	if (IDOK == Dlg.DoModal())
		::SendMessage(ActiveWindow, OL_INSERT, OL_NONODE, 
		  (LPARAM) (const char FAR *) Dlg.m_Text);
	
}

void CTestView::OnIndentIn()
{
	::SendMessage(ActiveWindow, OL_INDENT_IN, OL_NONODE, 0L);	
}

void CTestView::OnIndentOut()
{
	::SendMessage(ActiveWindow, OL_INDENT_OUT, OL_NONODE, 0L);	
}

void CTestView::OnUpdateGetFont(CCmdUI* pCmdUI)
{
	if (ActiveWindow == hWnd1)
		if (hFont1)            
			pCmdUI->Enable(TRUE);
		else
			pCmdUI->Enable(FALSE);
	else
		if (hFont2)
			pCmdUI->Enable(TRUE);
		else
			pCmdUI->Enable(FALSE);
}

void CTestView::OnUpdateEditUndo(CCmdUI* pCmdUI)
{
BOOL bUndo  = (BOOL) ::SendMessage(ActiveWindow, OL_CANUNDO, 0, 0L);

	pCmdUI->Enable(bUndo);	
}

void CTestView::OnEditUndo()
{
	::SendMessage(ActiveWindow, OL_UNDO, 0, 0L);	
}

BOOL CTestView::OnCommand(WPARAM wParam, LPARAM lParam)
{   
	char buf[255];
	buf[0] = '\0';
	             
	//Look for notification messages
	switch(HIWORD(lParam))
	{
		case OLN_ADDNODE:
			wsprintf(buf, "Adding node %d", wParam);
			break;                                
		case OLN_CHANGE:
			wsprintf(buf, "Changing node %d", wParam);
			break;
		case OLN_DELNODE:
			wsprintf(buf, "Deleting node %d", wParam);
			break;
		case OLN_INDENT:
			wsprintf(buf, "Indenting node %d", wParam);
			break;
		case OLN_INSNODE:
			wsprintf(buf, "Inserting node %d", wParam);
			break;
		case OLN_KILLFOCUS:           
			if ((HWND) wParam == hWnd1)
				wsprintf(buf, "Loosing focus from the first outline control");
			else
				wsprintf(buf, "Loosing focus from the second outline control");
			break;
		case OLN_SELCHANGE:
			wsprintf(buf, "Changing selection to node %d", wParam);
			break;
		case OLN_SETFOCUS:
			ActiveWindow = (HWND) LOWORD(lParam);
			if ((HWND) wParam == hWnd1)
				wsprintf(buf, "Setting focus to the first outline control");
			else
				wsprintf(buf, "Setting focus to the second outline control");
			break;         
		case OLN_VSCROLL:
			wsprintf(buf, "Scrolling outline control");
			break;
		case OLN_LBUTTONCLK:
			wsprintf(buf, "Left button click");
			break;
		case OLN_LBUTTONDBLCLK:
			wsprintf(buf, "Left button double click");
			break;
		case OLN_RBUTTONCLK:
			wsprintf(buf, "Right button click");
			break;
		case OLN_RBUTTONDBLCLK:
			wsprintf(buf, "Right button double click");
			break;
		case OLN_MBUTTONCLK:
			wsprintf(buf, "Middle button click");
			break;
		case OLN_MBUTTONDBLCLK:
			wsprintf(buf, "Middle button double click");
			break;
	}            
	if (lstrlen(buf))
	{
		CMainFrame *pFrame = (CMainFrame *) GetParentFrame();
		if (pFrame != NULL)
		{
			CRuntimeClass* prt = pFrame->GetRuntimeClass();
			ASSERT(lstrcmp(prt->m_lpszClassName, "CMainFrame") == 0);

			pFrame->setStatusText(buf);
		}
	}		
	return FALSE;		                             
}
void CTestView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	// resize each of the outline windows	
	if (hWnd1)
		::MoveWindow(hWnd1, 0, 0, cx / 2, cy, TRUE);
	
	if (hWnd2)
		::MoveWindow(hWnd2, cx / 2, 0, cx / 2, cy, TRUE);
}

void CTestView::OnStyle()
{
	// Get the current state of the numbering
	LONG lStyle = ::SendMessage(ActiveWindow, OL_GET_NUMBERING_STYLE, 0, 0L);
	
	// Get the current state of the numbering style option		           
	if (lStyle == OL_NUM_NONE)
		::SendMessage(ActiveWindow, OL_INDENT_NUMBERING, OL_NUM_NUMERIC, 0L);
	else
		::SendMessage(ActiveWindow, OL_INDENT_NUMBERING, OL_NUM_NONE, 0L);
}
